/*============================================================================
	SQL Server Versions: 2012 11.0.3321
------------------------------------------------------------------------------
	Copyright (C) 2012 Joe Sack, SQLskills.com
	All rights reserved. 

	For more scripts and sample code, check out
		http://www.sqlskills.com/ 

	You may alter this code for your own *non-commercial* purposes. You may
	republish altered code as long as you give due credit. 

	THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF
	ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
	TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
	PARTICULAR PURPOSE.
============================================================================*/ 

USE [Credit];
GO

-- Pushed predicate
-- Estimated cost?
-- I/O?

SELECT  [charge_no], [charge_amt]
FROM    [dbo].[charge]
WHERE   [charge_amt] > 4774.00
ORDER BY  [charge_no] ASC
OPTION  (RECOMPILE, MAXDOP 1);

-- Subtree cost 8.65365

-- And with the filter?
SELECT  [charge_no], [charge_amt]
FROM    [dbo].[charge]
WHERE   [charge_amt] > 4774.00
ORDER BY  [charge_no] ASC
OPTION  (RECOMPILE, MAXDOP 1, QUERYTRACEON 9130);

-- Subtree cost 9.42165 (vs. 8.65365)


-- Beyond mythical costs, any real difference?
SET STATISTICS TIME ON;

DBCC DROPCLEANBUFFERS;
SELECT  [charge_no], [charge_amt]
FROM    [dbo].[charge]
WHERE   [charge_amt] > 4774.00
ORDER BY  [charge_no] ASC
OPTION  (RECOMPILE, MAXDOP 1);

DBCC DROPCLEANBUFFERS;
SELECT  [charge_no], [charge_amt]
FROM    [dbo].[charge]
WHERE   [charge_amt] > 4774.00
ORDER BY  [charge_no] ASC
OPTION  (RECOMPILE, MAXDOP 1, QUERYTRACEON 9130);

SET STATISTICS TIME OFF;

