/*============================================================================
	SQL Server Versions: 2012 11.0.3321
------------------------------------------------------------------------------
	Copyright (C) 2012 Joe Sack, SQLskills.com
	All rights reserved. 

	For more scripts and sample code, check out
		http://www.sqlskills.com/ 

	You may alter this code for your own *non-commercial* purposes. You may
	republish altered code as long as you give due credit. 

	THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF
	ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
	TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
	PARTICULAR PURPOSE.
============================================================================*/ 


USE Credit;
GO

IF OBJECT_ID('charge_x') > 0
BEGIN
	DROP TABLE dbo.charge_x;
END

IF OBJECT_ID('charge_y') > 0
BEGIN
	DROP TABLE dbo.charge_y;
END


SELECT  [charge_no],
        [member_no],
        [provider_no],
        [category_no],
        [charge_dt],
        [charge_amt],
        [statement_no],
        [charge_code]
INTO dbo.charge_x
FROM dbo.[charge] AS c;

SELECT  [charge_no],
        [member_no],
        [provider_no],
        [category_no],
        [charge_dt],
        [charge_amt],
        [statement_no],
        [charge_code]
INTO dbo.charge_y
FROM dbo.[charge] AS c;

CREATE CLUSTERED INDEX charge_x_charge_no ON 
	charge_x(charge_no);
GO

CREATE CLUSTERED INDEX charge_y_charge_no ON 
	charge_y(charge_no);
GO

-- Work table for M2M?
-- Estimated Cost? 3.90683
SET STATISTICS IO ON;

SELECT TOP 10000 *
FROM dbo.charge_x AS x
INNER JOIN dbo.charge_y AS y ON
	x.charge_no = y.charge_no
OPTION (RECOMPILE);

SET STATISTICS IO OFF;


-- What if we create as UNIQUE?
CREATE UNIQUE CLUSTERED INDEX charge_x_charge_no ON 
	charge_x(charge_no)
WITH (DROP_EXISTING = ON);
GO

CREATE UNIQUE CLUSTERED INDEX charge_y_charge_no ON 
	charge_y(charge_no)
WITH (DROP_EXISTING = ON);
GO

-- Work table for M2M?
-- Cost? 0.323295
SET STATISTICS IO ON;

SELECT TOP 10000 *
FROM dbo.charge_x AS x
INNER JOIN dbo.charge_y AS y ON
	x.charge_no = y.charge_no
OPTION (RECOMPILE);

SET STATISTICS IO OFF;

-- Cleanup
IF OBJECT_ID('charge_x') > 0
BEGIN
	DROP TABLE dbo.charge_x;
END

IF OBJECT_ID('charge_y') > 0
BEGIN
	DROP TABLE dbo.charge_y;
END

