/*============================================================================
	SQL Server Versions: 2012 11.0.3321
------------------------------------------------------------------------------
	Copyright (C) 2012 Joe Sack, SQLskills.com
	All rights reserved. 

	For more scripts and sample code, check out
		http://www.sqlskills.com/ 

	You may alter this code for your own *non-commercial* purposes. You may
	republish altered code as long as you give due credit. 

	THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF
	ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
	TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
	PARTICULAR PURPOSE.
============================================================================*/ 

USE [AdventureWorksDW2012];
GO

CREATE INDEX fi_PromotionKey_by_CurrencyKey
ON dbo.FactInternetSales (PromotionKey)
WHERE CurrencyKey = 6;
GO

-- Ad hoc match?
DECLARE @CurrencyKey int = 6;

SELECT DISTINCT PromotionKey
FROM [dbo].[FactInternetSales]
WHERE CurrencyKey = @CurrencyKey;
GO

-- Stored procedure match?
CREATE PROCEDURE dbo.FIS_by_CurrencyKey 
	@CurrencyKey int
AS

SELECT DISTINCT PromotionKey
FROM [dbo].[FactInternetSales]
WHERE CurrencyKey = @CurrencyKey;
GO

EXEC dbo.FIS_by_CurrencyKey 6;
GO

-- What about this?
CREATE PROCEDURE dbo.FIS_by_CurrencyKey_v2
	@CurrencyKey int
AS

SELECT DISTINCT PromotionKey
FROM [dbo].[FactInternetSales]
WHERE CurrencyKey = @CurrencyKey
OPTION (RECOMPILE);
GO

EXEC dbo.FIS_by_CurrencyKey_v2 6;
GO


-- Cleanup
DROP INDEX fi_PromotionKey_by_CurrencyKey
ON dbo.FactInternetSales;
GO


DROP PROCEDURE dbo.FIS_by_CurrencyKey;
GO

DROP PROCEDURE dbo.FIS_by_CurrencyKey_v2;
GO
