/*============================================================================
	SQL Server Versions: 2012 11.0.3321
------------------------------------------------------------------------------
	Copyright (C) 2012 Joe Sack, SQLskills.com
	All rights reserved. 

	For more scripts and sample code, check out
		http://www.sqlskills.com/ 

	You may alter this code for your own *non-commercial* purposes. You may
	republish altered code as long as you give due credit. 

	THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF
	ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
	TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
	PARTICULAR PURPOSE.
============================================================================*/ 

USE [BigFactTable];
GO

/*
CREATE NONCLUSTERED COLUMNSTORE INDEX [NonClusteredColumnStoreIndex-20120427-064134] ON [dbo].[FactInternetSales]
(
	[ProductKey],
	[OrderDateKey],
	[DueDateKey],
	[ShipDateKey],
	[CustomerKey],
	[PromotionKey],
	[CurrencyKey],
	[SalesTerritoryKey],
	[SalesOrderNumber],
	[SalesOrderLineNumber],
	[RevisionNumber],
	[OrderQuantity],
	[UnitPrice],
	[ExtendedAmount],
	[UnitPriceDiscountPct],
	[DiscountAmount],
	[ProductStandardCost],
	[TotalProductCost],
	[SalesAmount],
	[TaxAmt],
	[Freight],
	[CarrierTrackingNumber],
	[CustomerPONumber],
	[OrderDate],
	[DueDate],
	[ShipDate]
)WITH (DROP_EXISTING = OFF) ON [PRIMARY]
GO
*/

SELECT  [partition_id],
        [hobt_id],
        [column_id],
        [segment_id],
        [version],
        [encoding_type],
        [row_count],
        [has_nulls],
        [base_id],
        [magnitude],
        [primary_dictionary_id],
        [secondary_dictionary_id],
        [min_data_id],
        [max_data_id],
        [null_value],
        [on_disk_size] 
FROM sys.column_store_segments 
WHERE column_id = 1 
ORDER BY segment_id;

-- Batch mode confirmation?
-- Any segment skips in the SQL Error Log?

DBCC TRACEON(3605, -1); 
GO 

DBCC TRACEON(646, -1); 
GO 

SELECT  [ProductKey],
        [DueDateKey],
        SUM(OrderQuantity) AS [Total_OrderQuantity]
FROM    [dbo].[FactInternetSales]
GROUP BY [ProductKey],
        [DueDateKey]
HAVING  [ProductKey] IN (343, 478, 574)
OPTION (RECOMPILE); 
GO

-- Segments


-- Cleanup
DBCC TRACEOFF(3605, -1); 
GO 

DBCC TRACEOFF(646, -1); 
GO 