/*============================================================================
	SQL Server Versions: 2012 11.0.3321
------------------------------------------------------------------------------
	Copyright (C) 2012 Joe Sack, SQLskills.com
	All rights reserved. 

	For more scripts and sample code, check out
		http://www.sqlskills.com/ 

	You may alter this code for your own *non-commercial* purposes. You may
	republish altered code as long as you give due credit. 

	THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF
	ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
	TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
	PARTICULAR PURPOSE.
============================================================================*/ 

USE [Credit];
GO

-- Pre SQL Server 2012 behavior
SET STATISTICS IO ON;

SELECT 	SUM([charge_amt]) AS [Total_Charge_Amts],
		COUNT(DISTINCT [charge_amt]) AS [Distinct_Categories]
FROM    dbo.[charge] AS c
OPTION (RECOMPILE, QUERYRULEOFF ReduceForDistinctAggs);

SET STATISTICS IO OFF;
GO

-- 2012 behavior
SET STATISTICS IO ON;

SELECT 	SUM([charge_amt]) AS [Total_Charge_Amts],
		COUNT(DISTINCT [charge_amt]) AS [Distinct_Categories]
FROM    dbo.[charge] AS c
OPTION (RECOMPILE);

SET STATISTICS IO OFF;
GO

-- 2012 behavior, multiple DISTINCT aggs
SET STATISTICS IO ON;

SELECT 	SUM([charge_amt]) AS [Total_Charge_Amts],
		COUNT(DISTINCT [charge_amt]) AS [Distinct_Categories],
		COUNT(DISTINCT [statement_no]) AS [Distinct_Statement_No]
FROM    dbo.[charge] AS c
OPTION (RECOMPILE);

SET STATISTICS IO OFF;
GO