/*============================================================================
	SQL Server Versions: 2012 11.0.3321
------------------------------------------------------------------------------
	Copyright (C) 2012 Joe Sack, SQLskills.com
	All rights reserved. 

	For more scripts and sample code, check out
		http://www.sqlskills.com/ 

	You may alter this code for your own *non-commercial* purposes. You may
	republish altered code as long as you give due credit. 

	THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF
	ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
	TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
	PARTICULAR PURPOSE.
============================================================================*/ 

USE [Credit];
GO

SELECT  [statement_no],
        [member_no],
        [statement_amt],
        [statement_code]
FROM    [dbo].[statement]
WHERE   [statement_dt] < [due_dt];
GO

ALTER TABLE [dbo].[statement]
ADD [delta_statement_due_dt] AS
(DATEDIFF(ms, [statement_dt], [due_dt]));
GO

SELECT  [statement_no],
        [member_no],
        [statement_amt],
        [statement_code],
        [delta_statement_due_dt]
FROM    [dbo].[statement]
WHERE   [delta_statement_due_dt] > 0;
GO

EXEC sp_helpstats 'statement';


-- Cleanup
ALTER TABLE [dbo].[statement]
DROP COLUMN [delta_statement_due_dt];
GO